export const DemoSourceCode = `
// slicing strings
print "one two three four"[4:7:1]; // prints two
print "hello world"[::-1]; //prints dlrow olleh

// range operator on list construction
print [0:10:3]; // prints a list [0,3,6,9]
print [1..5]; // prints [1,2,3,4,5]

// spread operator
print {...[1,2,3]}; // prints {0: 1; 1: 2; 2: 3}
print ...1..3 == ...1..3; // prints [true,true,true];
print ..."abz" <=> ..."ayc"; // prints [0,-1,1]


// functions
function BasicFunction(text) {
    print text;
}
BasicFunction('BasicFunctionArgument');

// classes
class Person {
    constructor(name) {
        this.name = name;
    }
    hello() {
        print this.name + ' says hi';
    }
}
class Student extends Person {
    constructor(name, grade) {
        base.constructor(name);
        this.grade = grade;
    }
    hello() {
        base.hello();
        print 'from ' + this.grade + ' grade';
    }
}
var student = new Student('John', 3);
student.hello();

// Recursive function
function factorialize(n) {
    if (n < 0) {
        return -1;
    }
    if (n == 0) {
        return 1;
    }
    return (n * factorialize(n - 1));
}
print 'factor of 11: ' + factorialize(11);
// same as factorialize but with ternary
// and short form function definition
@factor(n) =>
    n < 0 ? -1 : (n == 0 ? 1 : (n * factorialize(n - 1)));
print 'factor of 11: ' +factor(11);

// nested function returns function
@add(a) => @(b) => @(c) => a + b + c;
print add(100)(20)(3);

// literals
var literal = {
    firstname: "John",
    lastname: "Doe",
    records: {
        prev: "previous",
        next: "next"
    }
};
print literal.records.prev;

// safe navigator operator ?.
print literal.safeNavigator?.propertyDoesNotExist;

// delete operator
delete literal.firstname;

// new scope test
{
    var a = {a: 'one'};
    var b = {b: 'two'};
    var c = a + b;
    print c; // prints {a: 'one', b: 'two'}
}
// new scope test
{
    var a = {d: 'three'};
    var b = {e: 'four'};
    var c = a + b;
    print c; // prints {d: 'three', e: 'four'}
}

// typeof, is, instanceof operator
print typeof Person;
print typeof student;
print 'Student is Class: ' + (Student is Class);
print 'student is Object: ' + (student is Object);
print 'student is Person: ' + (student is Person);
print 'student is Student: ' + (student is Student);
print 'student instanceof Person: ' + (student instanceof Person);
print typeof '' + 'string';

// iterators
var it = iter(['one', 'two', 'three']);
while (!it.next().done) {
    print it.value;
}

// foreach statement
foreach (item with key in ['one', 'two', 'three']) {
    print item;
}

// foreach statement with none
foreach (item  in []) {
    print item;
} none {
    print "no items";
}

// spread operator
{
    var a1 = ['one', 'two', 'three'];
    var b2 = [...a1, ..."spreading"];
    var d3 = {
        ...a1,
        ..."spreding"
    };
    print b2;
    print d3;
}

// loggin into js console
echo ('execution finished');

// fetching data. Currently unparsed text
fetch ('https://jsonplaceholder.typicode.com/todos/1', @(res) {
    echo(res);
});


function testForStatementClosure() {
    var logs = [];
    for (var i = 0; i < 3; ++i) {
      logs[i] = @() {
         print i;
      };
    }
    for (var i = 0; i < 3; ++i) {
      logs[i]();
    }
}
// prints 0 1 2 and not 2 2 2
testForStatementClosure();
`;
